/*-----------------------------------------------

      File forceBG.c holds the programs that compute locally the
      forces.

      Author:   Wilm E. Donath
      Created;  January 20, 2000

      Additions or changes:

*/

#include <math.h>

null
#include <assert.h>
null
#include <stdio.h>
#include "md_macros.h"
#include "md_defines.h"
#include "BG_types.h"
#include "forceBG.h"
#include "proto_utils.h"


typedef char LINE[MAXLINELEN];

null
extern void force_eBG_A(hungry_puppy * puppy);
null

null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null


#define TPI  (2.*M_PI)
static int lineno=0;
static int forceBG_msg=0;
static int forceBG_msg2=0;
static int msg_force_cnt=0;

static int ecorr_msg=0;
void ecorr_BG(chip_type * chip,int itr,int jsc) {
  double xdis,ydis,zdis,dis2,dis;
  double dvecorr;
  double erfr,qijr,ralp,kappa,kappa2,sqrt_pi;
  T_type * tr=chip->tr;
  S_type * sc=chip->sc;
  force3 * fce = chip->fcl;
  char * id="[ecorr_BG]:";

  kappa=chip->kappa;
  kappa2=kappa*kappa;
  sqrt_pi=chip->sqrt_pi;
  if(!sc[jsc].charge)return;
  xdis = tr[itr].px - sc[jsc].px;
  ydis = tr[itr].py - sc[jsc].py;
  zdis = tr[itr].pz - sc[jsc].pz;
  dis2 = xdis*xdis+ydis*ydis+zdis*zdis;
  dis = sqrt(dis2);
  qijr = tr[itr].charge*sc[jsc].charge/dis;
  ralp = dis*kappa;
  erfr = erf(ralp);
  dvecorr = -qijr*(-2.*kappa*exp(-kappa2*dis2)/chip->sqrt_pi+erfr/dis);
  dvecorr /= dis;
  xdis *= dvecorr; ydis *= dvecorr; zdis *= dvecorr;
  fce[itr].fx += xdis;
  fce[itr].fy += ydis;
  fce[itr].fz += zdis;
} /* ecorr_BG */

null

/* the Lennard-Jones potential */
void force_LJ_BG(chip_type * chip,int iflg) {
  /* iflg = 1 means long range forces, iflg = 0 means short range */
  INTER_BG * inter;
  int j,k,ni,nj,ierror,jer,ic,jc,kc,i,jj,in;
  double f,fm1,f0,f1,p,swv,dis2,fcc,u_excl;
  double xdis,ydis,zdis,sx,sy,sz,x,y,z;
  double *rmin2,*rmax2,  * rminh2, * rmaxh2, rmaxg;
  int ntable;
  double * rmint2,* dx2tab,**dvtab;
  int * * imap;
  int TotalForces=0;
  /*int ivol;*/
  /* for computing distance in box */
  double hmxx,hmyy,hmzz,hmxxhalf,hmyyhalf,hmzzhalf;
  double * hmati,* hmat;
  force3 * fc;
  LINE line;
  double **sw;
  T_type * tr;
  excludeBG * Cexcl = chip->excl;
  int exclP=0;
  int compute_excl=1;
  int icell,icx,iperd,iensemble,dis_icell;
  BG_Cell_List * cell_list;
  int *cell_sort;
  int * atom_list;
  double dx2, * dtab;
  BG_Cell_Item * cell_items;
  int ncell,ncells,ncell2,ncellm1;
  int i2,j2,k2,is_valid_cell,iatom,tr_atom,sc_atom;
  S_type * sc;
  BGlink * first;
  char * idx="[force_LJ_BG]:";
  char id[256];
null
null
null
  rmin2=rmax2=rminh2=rmaxh2=rmint2=dx2tab=NULL;
  rmaxg=0;
  dvtab=sw=NULL;
  cell_items=NULL;
  atom_list=NULL;
  cell_list=NULL;
  cell_sort=NULL;
null
  sprintf(id," %s%d|%d_%d ",idx,iflg,chip->row,chip->col);
null

null
null
null
null

  jer = -1;
  ierror=0;
  hmat=chip->hmat;
  hmati=chip->hmati;
  chip->rvol=1.0/(gethinv9(hmat,hmati));
  iperd = chip->iperd;
  cell_list = chip->CellList;
  cell_sort = cell_list->sortlist;
  inter =  chip->inter;
  cell_items = cell_list->items;
  sc = chip->sc;
  ncell = chip->ncell;
  ncell2 = chip->ncell2;
  ncells = chip->ncells;
null
null
null
null
  /* switch to long pair or short pair */
  switch(iflg){
  case 0:
    rmax2 = inter->rmaxs_cut2;
    rmin2 = inter->rmins_cut2;
    rmaxg = inter->rmaxgs;
    sw   = inter->switchs;
    fc = chip->fcs;
    rminh2=inter->rminl_cut2;
    rmaxh2=inter->rmaxs_cut2;
    break;
  case 1:
    rmax2 = inter->rmaxl_cut2;
    rmin2 = inter->rminl_cut2;
    rmaxg = inter->rmaxgl;
    sw   = inter->switchl;
    fc = chip->fcl;
    rminh2=inter->rminl_cut2;
    rmaxh2=inter->rmaxs_cut2;
    break;
  default:
    md_error("ERROR: in inter-molecular force routine?!?!?");
  }
  S2cellsBG(chip,0);
null
null
null
null
null
null
  tr  = chip->tr;
  first=chip->first;
  dx2tab = inter->dx2tab;
  dvtab  = inter->dvtab ;
  rmint2 = inter->rmins_cut2;
  imap   = inter->imap;
  iensemble = chip->iensemble;
  if(iensemble<3) {
    hmxx=hmat[0]; hmyy=hmat[4]; hmzz=hmat[8];
    hmxxhalf=0.5*hmat[0]; hmyyhalf=0.5*hmat[4]; hmzzhalf=0.5*hmat[8];
null
null
null
null
null
null
  }

  for(j=0;j<chip->tr_count;j++) {
    jj=j;
    tr_atom=tr[jj].atom;
    /* find the cell the atom belongs in */
    x = tr[j].px;
    y = tr[j].py;
    z = tr[j].pz;
    sx = x*hmati[0]+y*hmati[1]+z*hmati[2];
    sy = x*hmati[3]+y*hmati[4]+z*hmati[5];
    sz = x*hmati[6]+y*hmati[7]+z*hmati[8];
null
null
null
null

    if(iperd>0) sx -= anint2(sx);
    if(iperd>1) sy -= anint2(sy);
    if(iperd>2) sz -= anint2(sz);
    ic = (int)((sx+.5)*ncell);
    jc = (int)((sy+.5)*ncell);
    kc = (int)((sz+.5)*ncell);
    ic = MAX(ic,0);
    jc = MAX(jc,0);
    kc = MAX(kc,0);
null
null
null
null
null
null
null
null
    is_valid_cell=1;
null
null
null
null
null
null
null
null
null
null
null
null
    icx=0;
    while(is_valid_cell) {
      exclP=0;
null
null
null
null
      icell=cell_sort[icx];
      i2 = ic + cell_items[icell].i;
      while(i2>=ncell)i2-=ncell;
      j2 = jc + cell_items[icell].j;
      while(j2>=ncell)j2-=ncell;
      k2 = kc + cell_items[icell].k;
      while(k2>=ncell)k2-=ncell;
      dis_icell=k2*ncell2 + j2*ncell+i2;
      /* now do all the atoms in the cell */
null
null
null
null
null
null
      for(iatom=first[dis_icell].next;iatom>=0;
	  iatom=sc[iatom].same_cell.next) {
	/* check on exclusion computation. If atom is in exclude list*/
	sc_atom=sc[iatom].atom;
null
null
null
null
null
null
null
null
	compute_excl=1;
	u_excl=0;
	if(sc_atom==tr_atom)compute_excl=0;
	else if(exclP<Cexcl[jj].n) {
	  while((sc_atom>Cexcl[jj].excl[exclP])&&(exclP<Cexcl[jj].n))exclP++;
	  if((exclP<Cexcl[jj].n)&&sc_atom==Cexcl[jj].excl[exclP]) {
	    compute_excl=0;
	  }
	} /* end of checking on exclusion */
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
	if(compute_excl) {
	  if (iperd == 3 ) {
	    if ( iensemble < 3 ) {
	      xdis = sc[iatom].px - x;
	      ydis = sc[iatom].py - y;
	      zdis = sc[iatom].pz - z;
	      while( xdis > hmxxhalf ) xdis -= hmxx ;
	      while( xdis < -hmxxhalf ) xdis += hmxx ;
	      while( ydis > hmyyhalf ) ydis -= hmyy ;
	      while( ydis < -hmyyhalf ) ydis += hmyy ;
	      while( zdis > hmzzhalf ) zdis -= hmzz ;
	      while( zdis < -hmzzhalf ) zdis += hmzz ;
	    }else {
	      xdis = sc[iatom].px - x;
	      ydis = sc[iatom].py - y;
	      zdis = sc[iatom].pz - z;
null
	      sx   = hmati[0]*xdis + ydis*hmati[1] + zdis * hmati[2];
	      sy   = hmati[3]*xdis + ydis*hmati[4] + zdis * hmati[5];
	      sz   = hmati[6]*xdis + ydis*hmati[7] + zdis * hmati[8];
	      sx -= anint2(sx);
	      sy -= anint2(sy);
	      sz -= anint2(sz);
	      xdis = sx*hmat[0]+sy*hmat[1]+sz*hmat[2];
	      ydis = sx*hmat[3]+sy*hmat[4]+sz*hmat[5];
	      zdis = sx*hmat[6]+sy*hmat[7]+sz*hmat[8];
null
null
null
null
null
null
null
null
null
	    }
	  }
	  if ( iperd == 1 ) {
	    xdis = sc[iatom].px - x;
	    sx =  xdis*hmati[0];
	    sx -= anint2(sx);
	    xdis = hmat[0]*sx;
	  }
	  if ( iperd == 2 ) {
	    xdis = sc[iatom].px-x;
	    ydis = sc[iatom].py-y;
	    sx = xdis*hmati[0]+ydis*hmati[1];
	    sy = xdis*hmati[3]+ydis*hmati[4];
	    sx -= anint2(sx);
	    sy -= anint2(sy);
	    xdis = sx*hmat[0]+sy*hmat[1];
	    ydis = sx*hmat[3]+sy*hmat[4];
	  }
	  /* now we are ready to compute force */
	  dis2 = xdis*xdis + ydis*ydis + zdis* zdis;
	  in = imap[tr[j].itype][sc[iatom].itype];
null
null
null
null
null
null
null
null
null
null
null
null
null
null

	  if(dis2>rmin2[in] && dis2<rmax2[in]){
	    TotalForces++;
	    p = (dis2-rmint2[in])*dx2tab[in];
	    k = (int)p;
	    if(k<1){ierror=1;jer = j;k=1;p=1.;}

	    p = p-(double)k;
	    fm1 = dvtab[in][k-1];
	    f0  = dvtab[in][k];
	    f1  = dvtab[in][k+1];
null
null
null
null
null
null
null

	    if((dis2>rminh2[in]) && (dis2<rmaxh2[in])){
	      fm1 = sw[in][k-1];
	      f0  = sw[in][k];
	      f1  = sw[in][k+1];
null
null
null
null
null
null
null
	    } else {
	      swv = 1.;
	    }

null
null
null
null
null
null
null
	    fcc = f*swv;
	    xdis *= fcc;
	    ydis *= fcc;
	    zdis *= fcc;
null
null
null
null
null
null
null
	    fc[jj].fx += xdis;
	    fc[jj].fy += ydis;
	    fc[jj].fz += zdis;
	  } else {
	    xdis = ydis = zdis = 0;
	  }
	}
      }
      icx++;
      icell=cell_sort[icx];
      if(cell_items[icell].R2>=rmaxg)is_valid_cell=0;
    }
null
null
null
null
null
null
  }
null
null
null
null
null
null
null
null
null
null
} /* force_LJ_BG */

static double pow6(double x) {
  x*=x;x*=(x*x);
  return(x);
} /* end pow6 */

/* the Lennard-Jones potential */
void force_LJ_BG_A(chip_type * chip,int iflg) {
  /* iflg = 1 means long range forces, iflg = 0 means short range */
  INTER_BG * inter;
  int j,k,ni,nj,ierror,jer,ic,jc,kc,i,jj,in;
  double f,fm1,f0,f1,p,swv,dis2,fcc,u_excl;
  double xdis,ydis,zdis,sx,sy,sz,x,y,z,rdis;
  double *rmin2,*rmax2,  * rminh2, * rmaxh2, rmaxg,*rminh;
  int ntable;
  double * rmint2,* dx2tab,**dvtab;
  int * * imap;
  int TotalForces=0;
  /*int ivol;*/
  /* for computing distance in box */
  double hmxx,hmyy,hmzz,hmxxhalf,hmyyhalf,hmzzhalf;
  double * hmati,* hmat;
  force3 * fc;
  LINE line;
  double **sw;
  T_type * tr;
  excludeBG * Cexcl = chip->excl;
  int exclP=0;
  int compute_excl=1;
  int icell,icx,iperd,iensemble,dis_icell;
  BG_Cell_List * cell_list;
  int *cell_sort;
  int * atom_list;
  double dx2, * dtab;
  BG_Cell_Item * cell_items;
  int ncell,ncells,ncell2,ncellm1;
  int i2,j2,k2,is_valid_cell,iatom,tr_atom,sc_atom;
  double * eps_val,*sig_val,*eps_sig,*inv_heal;
  double invx,v6,v12,epsv,xv;
  S_type * sc;
  BGlink * first;
  char * idx="[LJ_BG_A]:";
  char id[256];
null
null
null
  rmin2=rmax2=rminh2=rmaxh2=rmint2=dx2tab=NULL;
  rmaxg=0;
  dvtab=sw=NULL;
  cell_items=NULL;
  atom_list=NULL;
  cell_list=NULL;
  cell_sort=NULL;
null
  sprintf(id," %s%d|%d_%d ",idx,iflg,chip->row,chip->col);
null

null
null
null
null

  jer = -1;
  ierror=0;
  hmat=chip->hmat;
  hmati=chip->hmati;
  chip->rvol=1.0/(gethinv9(hmat,hmati));
  iperd = chip->iperd;
  cell_list = chip->CellList;
  cell_sort = cell_list->sortlist;
  inter =  chip->inter;
  eps_val = inter->eps_val;
  sig_val = inter->sig_val;
  eps_sig = inter->eps_sig;
  inv_heal = inter->inv_heal;
  cell_items = cell_list->items;
  sc = chip->sc;
  ncell = chip->ncell;
  ncell2 = chip->ncell2;
  ncells = chip->ncells;
null
null
null
null
  /* switch to long pair or short pair */
  switch(iflg){
  case 0:
    rmax2 = inter->rmaxs_cut2;
    rmin2 = inter->rmins_cut2;
    rmaxg = inter->rmaxgs;
    sw   = inter->switchs;
    fc = chip->fcs;
    rminh2=inter->rminl_cut2;
    rmaxh2=inter->rmaxs_cut2;
    break;
  case 1:
    rmax2 = inter->rmaxl_cut2;
    rmin2 = inter->rminl_cut2;
    rmaxg = inter->rmaxgl;
    sw   = inter->switchl;
    fc = chip->fcl;
    rminh2=inter->rminl_cut2;
    rmaxh2=inter->rmaxs_cut2;
    break;
  default:
    md_error("ERROR: in inter-molecular force routine?!?!?");
  }
  rminh =inter->rminl_cut;
  S2cellsBG(chip,0);
null
null
null
null
null
null
  tr  = chip->tr;
  first=chip->first;
  dx2tab = inter->dx2tab;
  dvtab  = inter->dvtab ;
  rmint2 = inter->rmins_cut2;
  imap   = inter->imap;
  iensemble = chip->iensemble;
  if(iensemble<3) {
    hmxx=hmat[0]; hmyy=hmat[4]; hmzz=hmat[8];
    hmxxhalf=0.5*hmat[0]; hmyyhalf=0.5*hmat[4]; hmzzhalf=0.5*hmat[8];
null
null
null
null
null
null
  }

  for(j=0;j<chip->tr_count;j++) {
    jj=j;
    tr_atom=tr[jj].atom;
    /* find the cell the atom belongs in */
    x = tr[j].px;
    y = tr[j].py;
    z = tr[j].pz;
    sx = x*hmati[0]+y*hmati[1]+z*hmati[2];
    sy = x*hmati[3]+y*hmati[4]+z*hmati[5];
    sz = x*hmati[6]+y*hmati[7]+z*hmati[8];
null
null
null
null

    if(iperd>0) sx -= anint2(sx);
    if(iperd>1) sy -= anint2(sy);
    if(iperd>2) sz -= anint2(sz);
    ic = (int)((sx+.5)*ncell);
    jc = (int)((sy+.5)*ncell);
    kc = (int)((sz+.5)*ncell);
    ic = MAX(ic,0);
    jc = MAX(jc,0);
    kc = MAX(kc,0);
null
null
null
null
null
null
null
null
    is_valid_cell=1;
null
null
null
null
null
null
null
null
null
null
null
null
    icx=0;
    while(is_valid_cell) {
      exclP=0;
null
null
null
null
      icell=cell_sort[icx];
      i2 = ic + cell_items[icell].i;
      while(i2>=ncell)i2-=ncell;
      j2 = jc + cell_items[icell].j;
      while(j2>=ncell)j2-=ncell;
      k2 = kc + cell_items[icell].k;
      while(k2>=ncell)k2-=ncell;
      dis_icell=k2*ncell2 + j2*ncell+i2;
      /* now do all the atoms in the cell */
null
null
null
null
null
null
      for(iatom=first[dis_icell].next;iatom>=0;
	  iatom=sc[iatom].same_cell.next) {
	/* check on exclusion computation. If atom is in exclude list*/
	sc_atom=sc[iatom].atom;
null
null
null
null
null
null
null
	compute_excl=1;
	u_excl=0;
	if(sc_atom==tr_atom)compute_excl=0;
	else if(exclP<Cexcl[jj].n) {
	  while((sc_atom>Cexcl[jj].excl[exclP])&&(exclP<Cexcl[jj].n))exclP++;
	  if((exclP<Cexcl[jj].n)&&sc_atom==Cexcl[jj].excl[exclP]) {
	    compute_excl=0;
	  }
	} /* end of checking on exclusion */
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
	if(compute_excl) {
	  if (iperd == 3 ) {
	    if ( iensemble < 3 ) {
	      xdis = sc[iatom].px - x;
	      ydis = sc[iatom].py - y;
	      zdis = sc[iatom].pz - z;
	      while( xdis > hmxxhalf ) xdis -= hmxx ;
	      while( xdis < -hmxxhalf ) xdis += hmxx ;
	      while( ydis > hmyyhalf ) ydis -= hmyy ;
	      while( ydis < -hmyyhalf ) ydis += hmyy ;
	      while( zdis > hmzzhalf ) zdis -= hmzz ;
	      while( zdis < -hmzzhalf ) zdis += hmzz ;
	    }else {
	      xdis = sc[iatom].px - x;
	      ydis = sc[iatom].py - y;
	      zdis = sc[iatom].pz - z;
null
	      sx   = hmati[0]*xdis + ydis*hmati[1] + zdis * hmati[2];
	      sy   = hmati[3]*xdis + ydis*hmati[4] + zdis * hmati[5];
	      sz   = hmati[6]*xdis + ydis*hmati[7] + zdis * hmati[8];
	      sx -= anint2(sx);
	      sy -= anint2(sy);
	      sz -= anint2(sz);
	      xdis = sx*hmat[0]+sy*hmat[1]+sz*hmat[2];
	      ydis = sx*hmat[3]+sy*hmat[4]+sz*hmat[5];
	      zdis = sx*hmat[6]+sy*hmat[7]+sz*hmat[8];
null
null
null
null
null
null
null
null
null
	    }
	  }
	  if ( iperd == 1 ) {
	    xdis = sc[iatom].px - x;
	    sx =  xdis*hmati[0];
	    sx -= anint2(sx);
	    xdis = hmat[0]*sx;
	  }
	  if ( iperd == 2 ) {
	    xdis = sc[iatom].px-x;
	    ydis = sc[iatom].py-y;
	    sx = xdis*hmati[0]+ydis*hmati[1];
	    sy = xdis*hmati[3]+ydis*hmati[4];
	    sx -= anint2(sx);
	    sy -= anint2(sy);
	    xdis = sx*hmat[0]+sy*hmat[1];
	    ydis = sx*hmat[3]+sy*hmat[4];
	  }
	  /* now we are ready to compute force */
	  dis2 = xdis*xdis + ydis*ydis + zdis* zdis;
	  in = imap[tr[j].itype][sc[iatom].itype];
null
null
null
null
null
null
null
null
null
null
null
null

	  if(dis2>rmin2[in] && dis2<rmax2[in]){
	    TotalForces++;
null
	    p = (dis2-rmint2[in])*dx2tab[in];
	    k = (int)p;
	    if(k<1){ierror=1;jer = j;k=1;p=1.;}

	    p = p-(double)k;
	    fm1 = dvtab[in][k-1];
	    f0  = dvtab[in][k];
	    f1  = dvtab[in][k+1];
null
null
null
null
null
null
null

	    if((dis2>rminh2[in]) && (dis2<rmaxh2[in])){
	      fm1 = sw[in][k-1];
	      f0  = sw[in][k];
	      f1  = sw[in][k+1];
null
null
null
null
null
null
null
	    } else {
	      swv = 1.;
	    }
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
	    fcc = f*swv;
	    xdis *= fcc;
	    ydis *= fcc;
	    zdis *= fcc;
null
null
null
null
null
null
null
	    fc[jj].fx += xdis;
	    fc[jj].fy += ydis;
	    fc[jj].fz += zdis;
	  } else {
	    xdis = ydis = zdis = 0;
	  }
	}
      }
      icx++;
      icell=cell_sort[icx];
      if(cell_items[icell].R2>=rmaxg)is_valid_cell=0;
    }
null
null
null
null
null
null
  }
null
null
null
null
null
null
null
null
null
null
} /* force_LJ_BG_A */

/* the coulombic forces */



null

null
null
null
null
static void *force_eBGthr(void* puppy_);
void force_eBG(hungry_puppy* puppy_);

void force_eBG_HP(chip_type * chip,int iflg,int nthreads) {
  BGLock clock;
  BGLock puppies;
  hungry_puppy hp;
  static pthread_attr_t att[256];      // !!DL
  static void * status[256];           // !!DL
  static pthread_t      pth[256];      // !!DL
  int i;
  static char id[256];                 // !!DL
  char * idx="[force_eBG_HP]";

  #if 1 /* !!DL */
  {
  int j;
  force3 * fc;

  if (iflg)
    fc = chip->fcl;
  else
    fc = chip->fcs;
  
  for(j=0;j<chip->trc_count;j++) 
     {
     int jj=chip->trc[j].seqno;
     fc[jj].fx = fc[jj].fy = fc[jj].fz = 0;
     }
  }
null

  if(nthreads>256) exit(100);
  /* create puppy interface */
null
null
null
  hp.chip=chip;
  hp.iflg=iflg;
  hp.lock=&clock;
  hp.puppies=&puppies;
null
null
null
null


  /* initialize locks */
  clock.counter=chip->trc_count;
  pthread_mutex_init(&clock.lock,NULL);
  puppies.counter=nthreads-1;
  pthread_mutex_init(&puppies.lock,NULL);

  /* start up threads */
  for(i=1;i<nthreads;i++) {
    int x;
    if(x=pthread_create(pth+i,NULL,force_eBGthr,(void*)&hp)) {
null
null
null
null
      abort();
    }
null
null
null
null
null
null
null
  }
null
  force_eBG(&hp);
null
null
null
  force_eBG_A(&hp);
#else
  force_eBG2(&hp);
null
null
  /* wait for all threads to finish */
  /*while(!puppies.counter)usleep(1);*/
  for(i=1;i<nthreads;i++)pthread_join( pth[i],   &status[i]);
null
null
null

  #if 1 /* !!DL: print the forces on each charge */
  {
  int j;
  force3 * fc;

  if (iflg)
    fc = chip->fcl;
  else
    fc = chip->fcs;
  
  for(j=0;j<chip->trc_count;j++) 
     {
     int jj=chip->trc[j].seqno;
     printf("%d: %f %f %f\n", jj, fc[jj].fx, fc[jj].fy, fc[jj].fz);
     }
  }
null


} /* force_eBG_HP */

static void *force_eBGthr(void * puppy_) {
  hungry_puppy * puppy=(hungry_puppy*)puppy_;
  BGLock * plock=puppy->puppies;
  char * idx="[force_eBGthr]";
  pthread_t tid;
  char id[256]; 
  int x;
  
null
null
null
null
null
null
null
null
null
null
null
null
  force_eBG(puppy);
null
null
null
  force_eBG_A(puppy);
#else
  force_eBG2(puppy);
null
null
  pthread_mutex_lock(&plock->lock);
  plock->counter--;
null
null
null
null
  pthread_mutex_unlock(&plock->lock);
  pthread_exit(0);
} /* force_eBGthr */

null


null


null
void force_eBG(hungry_puppy * puppy) {
  chip_type*chip = puppy->chip;
  int iflg = puppy->iflg;
  BGLock * lock = puppy->lock;
null
null
null
null

null
null
null
  /* iflg = 1 means long range forces, iflg = 0 means short range */
  INTER_BG * inter;
  int j,k,ni,nj,ierror,jer,ic,jc,kc,i,jj,pcount;
  double f,fm1,f0,f1,p,swv,dis2,fcc,u_excl;
  double xdis,ydis,zdis,sx,sy,sz,x,y,z;
  double rmin2,rmax2,rmins2;
  /* for computing distance in box */
  double hmxx,hmyy,hmzz,hmxxhalf,hmyyhalf,hmzzhalf;
  double * hmati,* hmat;
  force3 * fc;
  double *sw;
  T_type * tr;
  ChargeAtom * trc;
  int tr_count;
  char line[120];
  excludeBG * Cexcl = chip->excl;
  int exclP=0;
  int compute_excl=1;
  int icell,icx,iperd,iensemble,dis_icell;
  BG_Cell_List * cell_list;
  int *cell_sort;
  int * atom_list;
  double dx2, * dtab;
  BG_Cell_Item * cell_items;
  int ncell,ncells,ncell2,ncellm1;
  int i2,j2,k2,is_valid_cell,iatom,tr_atom,sc_atom;
null
null
null
  S_type * sc;
  BGlink * first;
  char * idx="[force_eBG]:";
  char id[256];
  int TotalForces=0;
null
null
null
  jer=0;
null
  sprintf(id,"%s%d|%d_%d",idx,iflg,chip->row,chip->col);
null
null
null
null

  /* for long forces, insert the atoms into their respective cells */
  /*S2cellsBG(chip,0);*/
  iperd = chip->iperd;
  cell_list = chip->CellList;
  cell_sort = cell_list->sortlist;
  inter =  chip->inter;
  cell_items = cell_list->items;
  dx2 = inter->dx2coul;
  dtab = inter->dcoultab;
null
null
null
null

  ierror = 0;
  hmati = chip->hmati;
  hmat  = chip->hmat;
  iensemble = chip->iensemble;
  if(iensemble<3) {
    hmxx=hmat[0]; hmyy=hmat[4]; hmzz=hmat[8];
    hmxxhalf=0.5*hmat[0]; hmyyhalf=0.5*hmat[4]; hmzzhalf=0.5*hmat[8];
null
null
null
null
null
null
  }
  sc = chip->sc;
  ncell = chip->ncell;
  ncell2 = chip->ncell2;
  ncells = chip->ncells;
  trc = chip->trc;
  tr  = chip->tr;
  first=chip->first;
  switch(iflg) {
  case 0:
    sw = inter->switchse;
    rmax2 = inter->rmaxs_coul2;
    rmin2 = inter->rmins_coul2;
    fc = chip->fcs;
    break;
  case 1:
    sw = inter->switchle;
    rmax2 = inter->rmaxl_coul2;
    rmin2 = inter->rminl_coul2;
    fc = chip->fcl;
    break;
  }
  rmins2 = inter->rmins_coul2;
null
null
null
null
  icx=0;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null

  /* loop over all charged atoms */
  pcount=0;
null
  while(1) {
    pthread_mutex_lock(&lock->lock);
null
null
null
null
null
null
null
null
    if(lock->counter<=0) {
      pthread_mutex_unlock(&lock->lock);
      return;
    }
    j=--lock->counter;
    pthread_mutex_unlock(&lock->lock);

null
null
null
    for(j=0;j<chip->trc_count;j++) {
null
null
null
null
null
      jj=trc[j].seqno;
      tr_atom=tr[jj].atom;
null
null
null
null
null
null
null
	/* find the cell the atom belongs in */
	x = trc[j].tx;
	y = trc[j].ty;
	z = trc[j].tz;
	sx = x*hmati[0]+y*hmati[1]+z*hmati[2];
	sy = x*hmati[3]+y*hmati[4]+z*hmati[5];
	sz = x*hmati[6]+y*hmati[7]+z*hmati[8];
	
	if(iperd>0) sx -= anint2(sx);
	if(iperd>1) sy -= anint2(sy);
	if(iperd>2) sz -= anint2(sz);
	ic = (int)((sx+.5)*ncell);
	jc = (int)((sy+.5)*ncell);
	kc = (int)((sz+.5)*ncell);
	ic = MAX(ic,0);
	jc = MAX(jc,0);
	kc = MAX(kc,0);
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
	/* now find all the cells within range of this target */
	is_valid_cell=1;
	icx=0;
null
	while(is_valid_cell) {
null
null
null
null
	
null
null
null
null
null
null
null
null
null
	    exclP=0;
	    icell=cell_sort[icx];
	    i2 = ic + cell_items[icell].i;
	    while(i2>=ncell)i2-=ncell;
	    j2 = jc + cell_items[icell].j;
	    while(j2>=ncell)j2-=ncell;
	    k2 = kc + cell_items[icell].k;
	    while(k2>=ncell)k2-=ncell;
	    dis_icell=k2*ncell2 + j2*ncell+i2;
	
null
null
null
null
null
	    /* now do all the atoms in the cell */
null
null
null
null
null
null
null
null
null
null
null
	    for(iatom=first[dis_icell].next;
null
		iatom>=0;
null
null
null
null
		iatom=sc[iatom].same_cell.next) {
	      /* check on exclusion computation. If atom is in exclude list and
		 iflg=0, (short range) computation is omitted. if long range, the
		 actual electronic term needs to be subtracted out */
	      sc_atom=sc[iatom].atom;
	      compute_excl=1;
	      u_excl=0;
	      if((sc_atom==tr_atom)||(sc[iatom].charge==0))compute_excl=0;
	      else if(exclP<Cexcl[jj].n) {
		while((sc_atom>Cexcl[jj].excl[exclP])&&(exclP<Cexcl[jj].n))exclP++;
		if((exclP<Cexcl[jj].n)&&sc_atom==Cexcl[jj].excl[exclP]) {
		
		  if(iflg)ecorr_BG(chip,jj,iatom);
		  compute_excl=0;
		}
	      }
null
null
null
null
null
null
null
	      if(
		 compute_excl
null
null
null
		 ) {
		if (iperd == 3 ) {
		  if ( iensemble < 3 ) {
		    xdis = sc[iatom].px - x;
		    ydis = sc[iatom].py - y;
		    zdis = sc[iatom].pz - z;
		    while( xdis > hmxxhalf ) xdis -= hmxx ;
		    while( xdis < -hmxxhalf ) xdis += hmxx ;
		    while( ydis > hmyyhalf ) ydis -= hmyy ;
		    while( ydis < -hmyyhalf ) ydis += hmyy ;
		    while( zdis > hmzzhalf ) zdis -= hmzz ;
		    while( zdis < -hmzzhalf ) zdis += hmzz ;
		
null
null
null
null
null
		
null
		  }else {
		    xdis = sc[iatom].px - x;
		    ydis = sc[iatom].py - y;
		    zdis = sc[iatom].pz - z;
null
null
null
null
null
null
		    sx   = hmati[0]*xdis + ydis*hmati[1] + zdis * hmati[2];
		    sy   = hmati[3]*xdis + ydis*hmati[4] + zdis * hmati[5];
		    sz   = hmati[6]*xdis + ydis*hmati[7] + zdis * hmati[8];
		    sx -= anint2(sx);
		    sy -= anint2(sy);
		    sz -= anint2(sz);
		    xdis = sx*hmat[0]+sy*hmat[1]+sz*hmat[2];
		    ydis = sx*hmat[3]+sy*hmat[4]+sz*hmat[5];
		    zdis = sx*hmat[6]+sy*hmat[7]+sz*hmat[8];
null
null
null
null
null
		  }
		}
		if ( iperd == 1 ) {
		  xdis = sc[iatom].px - x;
		  sx =  xdis*hmati[0];
		  sx -= anint2(sx);
		  xdis = hmat[0]*sx;
		}
		if ( iperd == 2 ) {
		  xdis = sc[iatom].px-x;
		  ydis = sc[iatom].py-y;
		  sx = xdis*hmati[0]+ydis*hmati[1];
		  sy = xdis*hmati[3]+ydis*hmati[4];
		  sx -= anint2(sx);
		  sy -= anint2(sy);
		  xdis = sx*hmat[0]+sy*hmat[1];
		  ydis = sx*hmat[3]+sy*hmat[4];
		}
		/* now we are ready to compute force */
		dis2 = xdis*xdis + ydis*ydis + zdis* zdis;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
		if(dis2<rmax2 && dis2 > rmin2 ) {
		  TotalForces++;
		  p = (dis2-rmins2)*dx2;
		  k = (int)p;
		
		  if(k<1){ierror = 1;jer = j;k=0;p=0;}
		
		  p = p-(double)k;
		
		  fm1 = sw[k-1];
		  f0  = sw[k];
		  f1  = sw[k+1];
null
null
null
null
null
null
null
null
null
null
null
null
null
		  fm1= dtab[k-1];
		  f0 = dtab[k];
		  f1 = dtab[k+1];
null
null
null
null
null
null
null
		  fcc = sc[iatom].charge * tr[jj].charge * f * swv + u_excl;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
		
null
null
null
null
null
null
		  xdis *= fcc;
		  ydis *= fcc;
		  zdis *= fcc;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
		  fc[jj].fx += xdis;
		  fc[jj].fy += ydis;
		  fc[jj].fz += zdis;
null
null
null
null
null
null
null
null
null
null
null
		} else {
		  xdis = ydis = zdis = 0;
		}
	      }
	
null
null
null
null
null
	    }
null
null
null
null
null
null
	    icx++;
	    icell=cell_sort[icx];
	    if(cell_items[icell].R2>=rmax2)is_valid_cell=0;
	
null
null
null
null
null
	  }
null
	}
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
} /* force_eBG */

null

null

null
null
void force_eBG_A(hungry_puppy * puppy) {
  chip_type*chip = puppy->chip;
  int iflg = puppy->iflg;
  BGLock * lock = puppy->lock;
#if defined(DEBUG_BG) | defined(DEBUG_xBG)
  pthread_t tid=pthread_self();
null
null

null
null
null
  /* iflg = 1 means long range forces, iflg = 0 means short range */
  INTER_BG * inter;
  int j,k,ni,nj,ierror,jer,ic,jc,kc,i,jj,pcount;
  double f,fm1,f0,f1,p,swv,dis2,fcc,u_excl;
  double xdis,ydis,zdis,sx,sy,sz,x,y,z;
  double rmin2,rmax2,rmins2,alpha;
  /* for computing distance in box */
  double hmxx,hmyy,hmzz,hmxxhalf,hmyyhalf,hmzzhalf;
  double * hmati,* hmat;
  force3 * fc;
  double *sw;
  T_type * tr;
  double rminl_coul;
  ChargeAtom * trc;
  int tr_count;
  char line[120];
  double sqMPI=sqrt(M_PI);
#if defined(DEBUG_BG)||defined(DEBUG_xBG)
  int call_erfc=0;
  int call_sqrt=0;
  int exclude_loop=0;
  int cell_lop=0;
null
null
null
null
  excludeBG * Cexcl = chip->excl;
  int exclP=0;
  int compute_excl=1;
  int icell,icx,iperd,iensemble,dis_icell;
  BG_Cell_List * cell_list;
  int *cell_sort;
  double dis,sm,br,rheal_res,heal_skin;
  int * atom_list;
  double dx2, * dtab;
  BG_Cell_Item * cell_items;
  int ncell,ncells,ncell2,ncellm1;
  int i2,j2,k2,is_valid_cell,iatom,tr_atom,sc_atom;
  S_type * sc;
  BGlink * first;
  char * idx="[force_eBG_A]:";
  char id[256];
  int TotalForces=0;
null
null
null
  jer=0;

null
  sprintf(id,"%s%d|%d_%d",idx,iflg,chip->row,chip->col);
null
null
null
null

  /* for long forces, insert the atoms into their respective cells */
  /*S2cellsBG(chip,0);*/
  iperd = chip->iperd;
  cell_list = chip->CellList;
  cell_sort = cell_list->sortlist;
  inter =  chip->inter;
  cell_items = cell_list->items;
  /*dx2 = inter->dx2coul;
  dtab = inter->dcoultab;*/
  alpha=chip->kappa;
null
null
null
null
  rheal_res = sqrt(inter->rminl_coul2)-sqrt(inter->rmaxs_coul2);
  ierror = 0;
  hmati = chip->hmati;
  hmat  = chip->hmat;
  iensemble = chip->iensemble;
  if(iensemble<3) {
    hmxx=hmat[0]; hmyy=hmat[4]; hmzz=hmat[8];
    hmxxhalf=0.5*hmat[0]; hmyyhalf=0.5*hmat[4]; hmzzhalf=0.5*hmat[8];
null
null
null
null
null
null
  }
  sc = chip->sc;
  ncell = chip->ncell;
  ncell2 = chip->ncell2;
  ncells = chip->ncells;
  trc = chip->trc;
  tr  = chip->tr;
  first=chip->first;
  switch(iflg) {
  case 0:
    sw = inter->switchse;
    rmax2 = inter->rmaxs_coul2;
    rmin2 = inter->rmins_coul2;
    fc = chip->fcs;
    break;
  case 1:
    sw = inter->switchle;
    rmax2 = inter->rmaxl_coul2;
    rmin2 = inter->rminl_coul2;
    fc = chip->fcl;
    break;
  }
  rmins2 = inter->rmins_coul2;
  rminl_coul=sqrt(inter->rminl_coul2);
null
null
null
null
  icx=0;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
  /* loop over all charged atoms */
  pcount=0;
null
  while(1) {
    pthread_mutex_lock(&lock->lock);
null
null
null
null
null
null
null
null
    if(lock->counter<=0) {
      pthread_mutex_unlock(&lock->lock);
      return;
    }
    j=--lock->counter;
    pthread_mutex_unlock(&lock->lock);

null
null
null
null
null
null
null
null
null
null
  for(j=0;j<chip->trc_count;j++) {
null
null
    jj=trc[j].seqno;
    tr_atom=tr[jj].atom;
    /* find the cell the atom belongs in */
    x = trc[j].tx;
    y = trc[j].ty;
    z = trc[j].tz;
    sx = x*hmati[0]+y*hmati[1]+z*hmati[2];
    sy = x*hmati[3]+y*hmati[4]+z*hmati[5];
    sz = x*hmati[6]+y*hmati[7]+z*hmati[8];

    if(iperd>0) sx -= anint2(sx);
    if(iperd>1) sy -= anint2(sy);
    if(iperd>2) sz -= anint2(sz);
    ic = (int)((sx+.5)*ncell);
    jc = (int)((sy+.5)*ncell);
    kc = (int)((sz+.5)*ncell);
    ic = MAX(ic,0);
    jc = MAX(jc,0);
    kc = MAX(kc,0);
null
null
null
null
null
null
null
null
null
null
    /* now find all the cells within range of this target */
    is_valid_cell=1;
    icx=0;
null
    while(is_valid_cell) {
null
null
null
null
      exclP=0;
      icell=cell_sort[icx];
      i2 = ic + cell_items[icell].i;
      while(i2>=ncell)i2-=ncell;
      j2 = jc + cell_items[icell].j;
      while(j2>=ncell)j2-=ncell;
      k2 = kc + cell_items[icell].k;
      while(k2>=ncell)k2-=ncell;
      dis_icell=k2*ncell2 + j2*ncell+i2;

null
null
null
null
null
      /* now do all the atoms in the cell */
null
      for(iatom=first[dis_icell].next;iatom>=0;iatom=sc[iatom].same_cell.next) {
null
null
null
null
null
	/* check on exclusion computation. If atom is in exclude list and
	   iflg=0, (short range) computation is omitted. if long range, the
	   actual electronic term needs to be subtracted out */
	sc_atom=sc[iatom].atom;
	compute_excl=1;
	u_excl=0;
	if((sc_atom==tr_atom)||(sc[iatom].charge==0))compute_excl=0;
	else if(exclP<Cexcl[jj].n) {
	  while((sc_atom>Cexcl[jj].excl[exclP])&&(exclP<Cexcl[jj].n))exclP++;
	  if((exclP<Cexcl[jj].n)&&sc_atom==Cexcl[jj].excl[exclP]) {

	    if(iflg)ecorr_BG(chip,jj,iatom);
	
	    compute_excl=0;
	  }
	}
null
null
null
null
null
null
null
null
	if(compute_excl) {
null
null
null
null
	  if (iperd == 3 ) {
	    if ( iensemble < 3 ) {
	      xdis = sc[iatom].px - x;
	      ydis = sc[iatom].py - y;
	      zdis = sc[iatom].pz - z;
	      while( xdis > hmxxhalf ) xdis -= hmxx ;
	      while( xdis < -hmxxhalf ) xdis += hmxx ;
	      while( ydis > hmyyhalf ) ydis -= hmyy ;
	      while( ydis < -hmyyhalf ) ydis += hmyy ;
	      while( zdis > hmzzhalf ) zdis -= hmzz ;
	      while( zdis < -hmzzhalf ) zdis += hmzz ;
null
null
null
null
null
	    }else {
	      xdis = sc[iatom].px - x;
	      ydis = sc[iatom].py - y;
	      zdis = sc[iatom].pz - z;
	      sx   = hmati[0]*xdis + ydis*hmati[1] + zdis * hmati[2];
	      sy   = hmati[3]*xdis + ydis*hmati[4] + zdis * hmati[5];
	      sz   = hmati[6]*xdis + ydis*hmati[7] + zdis * hmati[8];
	      sx -= anint2(sx);
	      sy -= anint2(sy);
	      sz -= anint2(sz);
	      xdis = sx*hmat[0]+sy*hmat[1]+sz*hmat[2];
	      ydis = sx*hmat[3]+sy*hmat[4]+sz*hmat[5];
	      zdis = sx*hmat[6]+sy*hmat[7]+sz*hmat[8];
	    }
	  }
	  if ( iperd == 1 ) {
	    xdis = sc[iatom].px - x;
	    sx =  xdis*hmati[0];
	    sx -= anint2(sx);
	    xdis = hmat[0]*sx;
	  }
	  if ( iperd == 2 ) {
	    xdis = sc[iatom].px-x;
	    ydis = sc[iatom].py-y;
	    sx = xdis*hmati[0]+ydis*hmati[1];
	    sy = xdis*hmati[3]+ydis*hmati[4];
	    sx -= anint2(sx);
	    sy -= anint2(sy);
	    xdis = sx*hmat[0]+sy*hmat[1];
	    ydis = sx*hmat[3]+sy*hmat[4];
	  }
	  /* now we are ready to compute force */
	  dis2 = xdis*xdis + ydis*ydis + zdis* zdis;
	  if(dis2<rmax2 && dis2 > rmin2 ) {
	    dis=sqrt(dis2);

	    if(iperd == 3){
	      /*func_kerf(dis,&f0,&f,&f1,alpha);*/
	      /*f = erfc(alpha*dis)/dis;*/
	      f = -erfc(alpha*dis)/(dis2*dis)
		-2.*alpha*exp(-alpha*alpha*dis2)/(sqMPI*dis2);
null
null
null
null
null
null
null
null
null
null

null
	    } else {
	      /*func_coul(dis,&f0,&f,&f1);*/
	      f=1./dis;
	    }
	    if(dis2>inter->rminl_coul2 && dis2 < inter->rmaxs_coul2){
	      TotalForces++;
null
null
null
               br = -(dis-rminl_coul)/rheal_res;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
	
null
	       sm = (1.+ br*br*(2.*br-3.));
	       if(iflg==0){
		 swv = sm;
	       }else{
		 swv = 1.-sm;
	       }
	    } else {
	      swv = 1.;
	    }
	
	    fcc = sc[iatom].charge * tr[jj].charge * f * swv;
null
null
null
	    xdis *= fcc;
	    ydis *= fcc;
	    zdis *= fcc;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
           fc[jj].fx += xdis;
           fc[jj].fy += ydis;
           fc[jj].fz += zdis;
	  } else {
	    xdis = ydis = zdis = 0;
	  }
	}

null
null
null
null
null
      }
null
null
null
null
null
null
      icx++;
      icell=cell_sort[icx];
      if(cell_items[icell].R2>=rmax2)is_valid_cell=0;

null
null
null
null
null
    }
  }
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
} /* force_eBG_A */

null
    /* for last invocation of BLUEGENE */




static int is2cell_cnt=0;

/* create the cell structure on the source atoms */
void S2cellsBG(chip_type * chip,int update_mode) {
  BG_Cell_List * CellList;
  int icell,ncells,ncell2,ncell,ncellm1,i,ic,jc,kc;
  double sx,sy,sz,x,y,z;
  int iperd;
  S_type * sc;
  double * hmati;
  BGlink * first;
  char * idx="[S2cellsBG]";
  char id[256];
  hmati=chip->hmati;
  sc  =chip->sc;
  CellList=chip->CellList;
  ncells=CellList->ncells;
  ncell =CellList->ncell;
  ncellm1=ncell-1;
  ncell2=CellList->ncell2;
  first = chip->first;
  iperd=chip->iperd;
null
null
null
null
null
null
  for(i=0;i<ncells;i++)first[i].next=first[i].prev=-1;
  if(!update_mode)for(i=0;i<chip->sc_count;i++)
    sc[i].same_cell.next=sc[i].same_cell.prev=-1;
null
null
null
null
  for(i=0;i<chip->sc_count;i++) {
null
null
null
null
null
null
null
null
null
null
null
    x  = sc[i].px;
    y  = sc[i].py;
    z  = sc[i].pz;
    sx = x*hmati[0]+y*hmati[1]+z*hmati[2];
    sy = x*hmati[3]+y*hmati[4]+z*hmati[5];
    sz = x*hmati[6]+y*hmati[7]+z*hmati[8];

    if(iperd>0) sx -= anint2(sx);
    if(iperd>1) sy -= anint2(sy);
    if(iperd>2) sz -= anint2(sz);
    ic = (int)((sx+.5)*ncell);
    jc = (int)((sy+.5)*ncell);
    kc = (int)((sz+.5)*ncell);
    ic = MAX(ic,0);
    jc = MAX(jc,0);
    kc = MAX(kc,0);
    ic = MIN(ic,ncellm1);
    jc = MIN(jc,ncellm1);
    kc = MIN(kc,ncellm1);
    icell = kc*ncell2+jc*ncell+ic;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
    if(!update_mode) {
null
null
null
null
null
null
null
null
      if(first[icell].prev>=0)sc[first[icell].prev].same_cell.next=i;
      else {
	first[icell].next=i;
      }
      sc[i].same_cell.next=-1;
      sc[i].same_cell.prev=first[icell].prev;
      first[icell].prev=i;
    } else {
      if(icell!=sc[i].cell) {
	if(sc[i].same_cell.prev>=0)sc[sc[i].same_cell.prev].same_cell.next=
				     sc[i].same_cell.next;
	else first[sc[i].cell].next=sc[i].same_cell.next;
	if(sc[i].same_cell.next>=0)sc[sc[i].same_cell.next].same_cell.prev=
				     sc[i].same_cell.prev;
	else first[sc[i].cell].prev=sc[i].same_cell.prev;
	sc[i].cell=icell;
      }
    }
  }
} /* S2cellsBG */

null


void fonefBG(chip_type * chip) {
  int k14,i,j,k,ii,ierror,jer=0,ibegin,iend,col,row;
  double qij;
  double f,p,fm1,f0,f1,f2;
  double xdis,ydis,zdis,dis2,fcc;
  force3* fc;
  int n14s,*i14,*j14,*i14dx;
  double **dv14tab,*r14min2,*r14max2,*dx214tab;
  double scale_onefour,scale_onefour_e;
  T_type * tr;
  ForceOnfo * onfo;
  char id[256];
  LINE line;
  int ipr=0;

null
  sprintf(id,"[fonefBG]%d_%d,%d:",chip->me,chip->row,chip->col);
null

null
null
null
null

  fc = chip->fcr;
  dv14tab   = chip->Forces->donfo.dv14tab;
  dx214tab  = chip->Forces->donfo.dx214tab;
  r14min2   = chip->Forces->donfo.r14min2;
  r14max2   = chip->Forces->donfo.r14max2;
  scale_onefour   = chip->Forces->donfo.scale_onefour;
  scale_onefour_e = chip->Forces->donfo.scale_onefour_e;
  tr        = chip->tr;
  row       = chip->row;
  col       = chip->col;
  onfo      = chip->Forces->onfo;
null
null
null
null
null
  for(k14=0;k14<chip->Forces->numForceOnfo;k14++) {
    i=onfo[k14].i;
    j=onfo[k14].j;
    ii=onfo[k14].type;
    xdis = tr[i].px - tr[j].px;
    ydis = tr[i].py - tr[j].py;
    zdis = tr[i].pz - tr[j].pz;

null
null
null
null
null
null
null

    dis2=xdis*xdis+ydis*ydis+zdis*zdis;

    if(dis2 < r14max2[ii]){
      p = (dis2-r14min2[ii])*dx214tab[ii];
      k = (int)p;
      if(k<1){ierror=1;jer = k14;k=1;p=1.;}
      p = p-(double)k;

      fm1 = dv14tab[ii][k-1];
      f0  = dv14tab[ii][k];
      f1  = dv14tab[ii][k+1];

null
null
null
null
null
null
null
      fcc = f*scale_onefour;
null
null
null
null
null

      if((qij = tr[i].charge*tr[j].charge) != 0){
	fcc -= qij*pow(dis2,-3./2.)*scale_onefour_e;
      }
null
null
null
null
null
null
null
null
null
null
null
null

      xdis  *= fcc;  ydis  *= fcc;  zdis  *= fcc;
      if(i<chip->tr_count) {
	fc[i].fx -= xdis;  fc[i].fy -= ydis;  fc[i].fz -= zdis;
      }
      if(j<chip->tr_count) {
	fc[j].fx += xdis;  fc[j].fy += ydis;  fc[j].fz += zdis;
      }
null
null
null
null
null
null
null
    }
  }
null

null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
} /* fonefBG */

void ftorsBG(chip_type * chip) {
  int i,j,k,l,i_tors,nt,ii,ibegin,iend,idx,row,col;
  double ax,ay,az,bx,by,bz,cx,cy,cz;
  double dx,dy,dz,dl,dl2,ex,ey,ez,el,el2;
  double phi,cphi,dphi,dphidcos,dudphi,dudcos=0.;
  double g,dre,erd,r11;
  double dfx1,dfy1,dfz1,dfx2,dfy2,dfz2,dfx3,dfy3,dfz3,dfx4,dfy4,dfz4;
  double dgx1,dgy1,dgz1,dgx2,dgy2,dgz2,dgx3,dgy3,dgz3,dgx4,dgy4,dgz4;
  int ipos,jpos,lpos,kpos;
  double *eqtors,*fktors;
  int *ind_pot,*ind_pot_num;
  ForceTors * tors;
  T_type * tr;
  force3 * fc;
  double* *vphi;
  char id[256];
null
null
null

null
  sprintf(id,"[ftorsBG]%d_%d,%d:",chip->me,chip->row,chip->col);
null
null
null
null
null
  eqtors     = chip->Forces->dtors.eqtors;
  fktors     = chip->Forces->dtors.fktors;
  vphi       = (double**)chip->Forces->dtors.vphi;
  ind_pot    = chip->Forces->dtors.ind_pot;
  ind_pot_num= chip->Forces->dtors.ind_pot_num;
  fc         = chip->fcr;
  tr         = chip->tr;
  row        = chip->row;
  col        = chip->col;
  tors       = chip->Forces->tors;
null

null
null
null
null
null
null
null
null
null
null
null
null
  for(nt=0;nt<chip->Forces->numForceTors;nt++) {
    i=tors[nt].i;
    j=tors[nt].j;
    k=tors[nt].k;
    l=tors[nt].l;
    ipos = i;
    jpos = j;
    kpos = k;
    lpos = l;
    idx  = tors[nt].idxtors;
null

null
null
null
null
null
null
null

null

    ax   = tr[ipos].px - tr[jpos].px;
    ay   = tr[ipos].py - tr[jpos].py;
    az   = tr[ipos].pz - tr[jpos].pz;

    bx   = tr[jpos].px - tr[kpos].px;
    by   = tr[jpos].py - tr[kpos].py;
    bz   = tr[jpos].pz - tr[kpos].pz;

    cx   = tr[kpos].px - tr[lpos].px;
    cy   = tr[kpos].py - tr[lpos].py;
    cz   = tr[kpos].pz - tr[lpos].pz;

    dx = ay*bz - az*by;
    dy = az*bx - ax*bz;
    dz = ax*by - ay*bx;
    dl2= dx*dx+dy*dy+dz*dz;
    dl = sqrt(dl2);

    ex=by*cz - bz*cy;
    ey=bz*cx - bx*cz;
    ez=bx*cy - by*cx;
    el2=ex*ex+ey*ey+ez*ez;
    el=sqrt(el2);
null

null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null

    cphi=(dx*ex+dy*ey+dz*ez)/(dl*el);

    i_tors = ind_pot_num[idx];
null
null
null
null
null
null
null
null
null

    switch(ind_pot[idx]){
    case 0:
      if(cphi>=1.0) {
        phi      = 0.;
	dphi = phi - eqtors[i_tors];
	dudphi   = 0.;
	dphidcos = 0.;
	dudcos   = 0.;
      }	else {
	phi = acos(cphi);
	dphi = phi - eqtors[i_tors];
	dudphi = fktors[i_tors]*dphi;
	dphidcos = -1./sqrt(1.-cphi*cphi);
	dudcos  = dudphi*dphidcos;
      }
null
null
null
null
null
null
null
      break;
    case 1:
null
null
null
null
null
null
null
null
      /*
      tpot = vphi[i_tors][MAXPOWER_TORS-1];
      for(ii=MAXPOWER_TORS-2;ii>=0;ii--){
	tpot = tpot*cphi + vphi[i_tors][ii];
      } */

      dudcos = ((double)MAXPOWER_TORS-1.)*vphi[i_tors][MAXPOWER_TORS-1];
null
null
null
null
null
null
null
null
null
      for(ii=MAXPOWER_TORS-2;ii>0;ii--) {
	dudcos = dudcos*cphi + vphi[i_tors][ii]*(double)ii;
null
null
null
null
null
null
null
      }
      break;
    }
    /* Derivatives to f=d.e, g=dl*el  */

    g=dl*el;
    dre=dl/el;
    erd=el/dl;
    r11=1./g;
null
null
null
null
null
null
null

    dfx1 = by*ez - bz*ey;
    dfy1 = bz*ex - bx*ez;
    dfz1 = bx*ey - by*ex;

    dfx2 = (cy*dz-cz*dy+(az+bz)*ey-(ay+by)*ez);
    dfy2 = (cz*dx-cx*dz+(ax+bx)*ez-(az+bz)*ex);
    dfz2 = (cx*dy-cy*dx+(ay+by)*ex-(ax+bx)*ey);

    dfx3 = (ay*ez-az*ey+(bz+cz)*dy-(by+cy)*dz);
    dfy3 = (az*ex-ax*ez+(bx+cx)*dz-(bz+cz)*dx);
    dfz3 = (ax*ey-ay*ex+(by+cy)*dx-(bx+cx)*dy);

    dfx4 = by*dz - bz*dy;
    dfy4 = bz*dx - bx*dz;
    dfz4 = bx*dy - by*dx;

    dgx1 = (by*dz - bz*dy)*erd;
    dgy1 = (bz*dx - bx*dz)*erd;
    dgz1 = (bx*dy - by*dx)*erd;

    dgx2 = ((dy*(az+bz)-dz*(ay+by))*erd+(cy*ez-cz*ey)*dre);
    dgy2 = ((dz*(ax+bx)-dx*(az+bz))*erd+(cz*ex-cx*ez)*dre);
    dgz2 = ((dx*(ay+by)-dy*(ax+bx))*erd+(cx*ey-cy*ex)*dre);

    dgx3 = ((ay*dz-az*dy)*erd+(ey*(bz+cz)-ez*(by+cy))*dre);
    dgy3 = ((az*dx-ax*dz)*erd+(ez*(bx+cx)-ex*(bz+cz))*dre);
    dgz3 = ((ax*dy-ay*dx)*erd+(ex*(by+cy)-ey*(bx+cx))*dre);

    dgx4 = (by*ez - bz*ey)*dre;
    dgy4 = (bz*ex - bx*ez)*dre;
    dgz4 = (bx*ey - by*ex)*dre;

    dudcos *= r11;
null
null
null
null
null
null
null
null
null
null
null
null
null

    if(i<chip->tr_count) {
      fc[ipos].fx -= dudcos*(dfx1 - cphi*dgx1);
      fc[ipos].fy -= dudcos*(dfy1 - cphi*dgy1);
      fc[ipos].fz -= dudcos*(dfz1 - cphi*dgz1);
    }
    if(j<chip->tr_count) {
      fc[jpos].fx -= dudcos*(dfx2 - cphi*dgx2);
      fc[jpos].fy -= dudcos*(dfy2 - cphi*dgy2);
      fc[jpos].fz -= dudcos*(dfz2 - cphi*dgz2);
    }
    if(k<chip->tr_count) {
      fc[kpos].fx -= dudcos*(dfx3 - cphi*dgx3);
      fc[kpos].fy -= dudcos*(dfy3 - cphi*dgy3);
      fc[kpos].fz -= dudcos*(dfz3 - cphi*dgz3);
    }
    if(l<chip->tr_count) {
      fc[lpos].fx -= dudcos*(dfx4 - cphi*dgx4);
      fc[lpos].fy -= dudcos*(dfy4 - cphi*dgy4);
      fc[lpos].fz -= dudcos*(dfz4 - cphi*dgz4);
    }
null
null
null
null
null
null
null
null
  }
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
} /* ftorsBG */

void fbondBG(chip_type * chip) {
  int i,j,itype,nb,i2,tr_count,tr_x_count,iii;
  double eqbond,fkbond,dx,dy,dz,dr,r,fr;
  T_type * tr;
  ForceStruct * Fstr=chip->Forces;
  ForceBond * FB = Fstr->bonds;
  force3 * iF=Fstr->intrF;
  char id[256];
null
null
null
  tr=chip->tr;
  tr_count=chip->tr_count;
  tr_x_count=chip->tr_x_count;
  i2=Fstr->numForceBond;
null
null
null
null
  for(nb=0;nb<i2;nb++) {
    i=FB[nb].i;
    j=FB[nb].j;
null
null
null
null
null
null
null
null
null
null
    eqbond = FB[nb].eqbond;
    fkbond = FB[nb].fkbond;
    dx = tr[i].px-tr[j].px;
    dy = tr[i].py-tr[j].py;
    dz = tr[i].pz-tr[j].pz;
    r  = sqrt ( dx*dx + dy * dy + dz*dz );
null
null
null
null
null
null
null
null
    dr = r - eqbond;
    fr = fkbond*dr/r;

    dx *= fr; dy *= fr; dz *= fr;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
    if(i<chip->tr_count) {
      iF[i].fx -= dx;
      iF[i].fy -= dy;
      iF[i].fz -= dz;
    }
    if(j<chip->tr_count) {
      iF[j].fx += dx;
      iF[j].fy += dy;
      iF[j].fz += dz;
    }
null
null
null
null
null
null
null
null
null
  }
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
} /* fbondBG */

void fbendBG(chip_type * chip) {
  int i,j,k,itype,nb,i1,i2;
  double adotb,r11,costh,th,dudth,dthdcos,fact,dth;
  double dcdx1,dcdy1,dcdz1,dcdx2,dcdy2,dcdz2,dcdx3,dcdy3,dcdz3;
  double ax,ay,az,bx,by,bz,nal,nbl;
  double eqbend,fkbend;
  char id[256];

  T_type * tr;
  ForceStruct * Fstr = chip->Forces;
  force3 * iF;
  ForceBend  * FB = Fstr->bends;
  tr=chip->tr;
  /*i1=Fstr->i1Bend;
    i2=Fstr->i2Bend;*/
  i1=0;
  iF=Fstr->intrF;
null
  sprintf(id,"[fbendBG]%d_%d,%d:",chip->me,chip->row,chip->col);
null
null
null
null
null
null
null
null
null
null
null
null
null
null
  i2=Fstr->numForceBend;
  for(nb=i1;nb<i2;nb++) {
    i=FB[nb].i;
    j=FB[nb].j;
    k=FB[nb].k;
    itype=FB[nb].type;
    eqbend=Fstr->dbend->eqbend[itype];
    fkbend=Fstr->dbend->fkbend[itype];
null
null
null
null
null
    ax=tr[i].px-tr[j].px;
    ay=tr[i].py-tr[j].py;
    az=tr[i].pz-tr[j].pz;

    bx=tr[k].px-tr[j].px;
    by=tr[k].py-tr[j].py;
    bz=tr[k].pz-tr[j].pz;

    nal=1.0/(ax*ax+ay*ay+az*az);
    nbl=1.0/(bx*bx+by*by+bz*bz);
    adotb = ax*bx + ay*by + az*bz;
    r11 = sqrt(nal*nbl);
    costh = adotb*r11;
    if(fabs(costh) >= 1.){
      th = 1.;
      dth = th - eqbend;

      dthdcos = -1.;
      dudth = 0.;
    } else {
      th = acos(costh);
      dth = th - eqbend;

      dudth   = fkbend*dth;
      dthdcos = -1./sqrt(1.-costh*costh);
    }

    dcdx1 = costh*ax*nal - bx*r11;
    dcdy1 = costh*ay*nal - by*r11;
    dcdz1 = costh*az*nal - bz*r11;
    dcdx3 = costh*bx*nbl - ax*r11;
    dcdy3 = costh*by*nbl - ay*r11;
    dcdz3 = costh*bz*nbl - az*r11;
    dcdx2 = -dcdx1-dcdx3;
    dcdy2 = -dcdy1-dcdy3;
    dcdz2 = -dcdz1-dcdz3;

    fact = dudth*dthdcos;

null
null
null
null
null
null
null
null
null
    if(i<chip->tr_count) {
      iF[i].fx += fact*dcdx1;
      iF[i].fy += fact*dcdy1;
      iF[i].fz += fact*dcdz1;
    }
    if(j<chip->tr_count) {
      iF[j].fx += fact*dcdx2;
      iF[j].fy += fact*dcdy2;
      iF[j].fz += fact*dcdz2;
    }
    if(k<chip->tr_count) {
      iF[k].fx += fact*dcdx3;
      iF[k].fy += fact*dcdy3;
      iF[k].fz += fact*dcdz3;
    }
  }
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null

} /* fbendBG */

/*  Inputs to this program:
      a list of charged atoms in Tr with position and charge values
      values of cossc and sinsc of these atoms (computed earlier)
      a list of k vectors.
    for each atom hel.r and hel.i are to be computed.
    sum_hel.r and sum_hel.i for all k vectors is the output of this program
*/
void BG_hel_compute(chip_type * chip) {
  int i,j,k,kk,kx,ky,kz,kz1,kz2,mm;
  double aka,akb,akc,cossc,sinsc,six,siy,siz,tx,ty,tz,rk,
    helr,heli,charge,rhr,rhi,rvol;
  double * hmat=chip->hmat;
  k_vector * kv=chip->kv;
  double *hmati=chip->hmati;
  d_pair*sum_hel=chip->sum_hel;
  ChargeAtom * trc;
  char * idx="[BG_hel_comp]";
  char id[256];
  d_pair * hel;
  hel=(d_pair*)cmalloc(sizeof(d_pair)*chip->trc_count);

null
  sprintf(id,"%s%2d_%d,%d:",idx,chip->me,chip->row,chip->col);
null
null
null
null
null
null
null
null


  /* assume that in trc on chip the values
     tx,ty,tz, cossc,sinsc have been set */
  /* zero the sum_hel values */
  sum_hel=chip->sum_hel;
  for(k=0;k<chip->kval_count;k++) {
    sum_hel[k].r=sum_hel[k].i=0;
  }
  kk=0;/* holds the vector one is working on*/
  trc=chip->trc;
  /* initialize the cossc sinsc values */
  for(j=0;j<chip->trc_count;j++) {
    tx=trc[j].tx;
    ty=trc[j].ty;
    tz=trc[j].tz;
    akc=TPI*(tx*hmati[6]+ty*hmati[7]+tz*hmati[8]);
    trc[j].cossc=cos(akc);
    trc[j].sinsc=sin(akc);
null
null
null
null
null
null
  }
  rvol=chip->rvol=(1.0/ gethinv9(hmat,hmati));
null
null
null
null
null
null
null
  for(k=0;k<chip->kv_count;k++) {
    kz=kz1=chip->kv[k].kz1;
    kz2=chip->kv[k].kz2;
    ky=chip->kv[k].ky;
    kx=chip->kv[k].kx;
    six = TPI*kx;  siy=TPI*ky;  siz=TPI*kz1;
    aka = (six*hmati[0] + siy*hmati[3] + siz*hmati[6]);
    akb = (six*hmati[1] + siy*hmati[4] + siz*hmati[7]);
    akc = (six*hmati[2] + siy*hmati[5] + siz*hmati[8]);
    for(j=0;j<chip->trc_count;j++) {
      charge=trc[j].charge;

      tx=trc[j].tx;
      ty=trc[j].ty;
      tz=trc[j].tz;
      kz=kz1;
      mm=0;
      rk=(tx*aka + ty*akb + tz*akc);
      hel[j].r = cos(rk);
      hel[j].i = sin(rk);

      sum_hel[kk+mm].r+=charge*hel[j].r;
      sum_hel[kk+mm].i+=charge*hel[j].i;
      if(kz1<kz2) {
	cossc = trc[j].cossc;
	sinsc = trc[j].sinsc;
      }
null
null
null
null
null
null
null
null
null
      while(kz<kz2) {
	kz++;
	mm++;
	rhr=hel[j].r;   rhi=hel[j].i;
	hel[j].r = rhr*cossc-rhi*sinsc;
	hel[j].i = rhi*cossc+rhr*sinsc;

	sum_hel[kk+mm].r+=(charge*hel[j].r);
	sum_hel[kk+mm].i+=(charge*hel[j].i);
      }
    }
    kk+=(kz2-kz1+1);
  }
  free((void*)hel);
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
} /* BG_hel_compute */

void BG_fk_force(chip_type * chip) {
  int i,j,k,kk,kx,ky,kz,kz1,kz2,mm,jj;
  double aka,akb,akc,cossc,sinsc,six,siy,siz,tx,ty,tz,rk,xsumr,xsumi,
    helr,heli,charge,rhr,rhi,rvol,g2,g2i,falp2,preg,prep,sumr,sumi,smag,
    srx,sry,srz;
  double *hmati=chip->hmati;
  d_pair*sum_hel=chip->sum_hel;
  double * vp_local_tensor;
  k_vector * kv=chip->kv;
  force3 * fce=chip->fcl;
  char * id="[BG_fk_force]:";
  d_pair * hel;
  T_type * tr=chip->tr;
  force3 * ftest;
null
null
null
null
null
null
null
null
null


  vp_local_tensor=(chip->vp_local_tensor);
  for(j=0;j<9;j++)vp_local_tensor[j]=0;
  chip->vp_local=chip->vk_local=0;
  falp2=chip->falp2;
  rvol=chip->rvol;
null
null
null
null
null
  hel=(d_pair*)cmalloc(sizeof(d_pair)*chip->trc_count);

  kk=0;/* holds the vector one is working on*/
  for(k=0;k<chip->kv_count;k++) {
    kz1=kv[k].kz1;
    kz2=kv[k].kz2;
    ky=kv[k].ky;
    kx=kv[k].kx;
    six = TPI*kx;  siy=TPI*ky;  siz=TPI*kz1;
    aka = (six*hmati[0] + siy*hmati[3] + siz*hmati[6]);
    akb = (six*hmati[1] + siy*hmati[4] + siz*hmati[7]);
    akc = (six*hmati[2] + siy*hmati[5] + siz*hmati[8]);
    for(kz=kz1;kz<=kz2;kz++) {
      g2=aka*aka+akb*akb+akc*akc;
      g2i=1.0/g2;
      preg= exp(-g2*falp2)*rvol*g2i;
      prep = -2*preg*(g2*falp2+1)*g2i;
      sumr=chip->sum_hel[kk].r;
      sumi=chip->sum_hel[kk].i;
      smag=sumr*sumr+sumi*sumi;
      chip->vk_local+=(preg*smag);
      chip->vp_local+=(prep*smag*g2);

      vp_local_tensor[0] += prep*smag*aka*aka;
      vp_local_tensor[1] += prep*smag*akb*aka;
      vp_local_tensor[2] += prep*smag*akc*aka;

      vp_local_tensor[3] += prep*smag*aka*akb;
      vp_local_tensor[4] += prep*smag*akb*akb;
      vp_local_tensor[5] += prep*smag*akc*akb;

      vp_local_tensor[6] += prep*smag*aka*akc;
      vp_local_tensor[7] += prep*smag*akb*akc;
      vp_local_tensor[8] += prep*smag*akc*akc;
null
null
null
null
null
      xsumr = sumr*2*preg;
      xsumi = sumi*2*preg;
null
null
null
null
null
      for(j=0;j<chip->trc_count;j++) {
	charge=chip->trc[j].charge;
	tx=chip->trc[j].tx;
	ty=chip->trc[j].ty;
	tz=chip->trc[j].tz;
	jj=chip->trc_list[j];
null
null
null
null
null
null

null
null
null
null
null
	cossc = chip->trc[j].cossc;
	sinsc = chip->trc[j].sinsc;
	if(kz==kz1) {
	  rk= (tx*aka+ty*akb+tz*akc);
	  hel[j].r=cos(rk);
	  hel[j].i=sin(rk);
	} else {
	  rhr=hel[j].r;    rhi=hel[j].i;
	  hel[j].r = rhr*cossc - rhi*sinsc;
	  hel[j].i = rhi*cossc + rhr*sinsc;
null
null
null
null
null
null
	}
	/* now update the forces */
	rhr = hel[j].r;  rhi = hel[j].i;
	srx = aka*xsumr*charge; sry=akb*xsumr*charge; srz=akc*xsumr*charge;
	six = aka*xsumi*charge; siy=akb*xsumi*charge; siz=akc*xsumi*charge;

	fce[jj].fx += srx*rhi - six*rhr;
	fce[jj].fy += sry*rhi - siy*rhr;
	fce[jj].fz += srz*rhi - siz*rhr;
null

null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
      }
      if(kz<kz2) {
	aka+=(hmati[6]*TPI);
	akb+=(hmati[7]*TPI);
	akc+=(hmati[8]*TPI);
      }
      kk++;
    }
  }
  free((void*)hel);
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
} /* BG_fk_force */

/*
  The input variable "type" controls as follows:
     3 - advance for bond and bend only (strong intramolecular)
     2 - advance for weak intramolecular forces and make 0
     1 - advance for short range intermolecular forces and go to 2
     0 - advance also for long range forces
*/
void AdvanceAtoms(chip_type * chip,int type) {
  int i,n;
  force3 * fcl,* fcs, * fcr,*fci;
  double * imass=chip->inv_mass;
  double stepl,steps,stepr,stepi,mm;
  T_type * tr;
  LOCS * vel;
  char * idx="[AdvanceAtoms]";
  char id[256];
  tr=chip->tr;
  vel=chip->tr_vel;
  n=chip->tr_count;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
  if(chip->nfreeze>0)freeze_atom_BG(chip);
  switch(type) {
  case 0:
    fcl = chip->fcl;
    for(i=0;i<n;i++) {
      fcl[i].fx*=imass[i];
      fcl[i].fy*=imass[i];
      fcl[i].fz*=imass[i];
    }
    stepl = chip->stepl;
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
  case 1:
    fcs = chip->fcs;
    steps = chip->steps;
    for(i=0;i<n;i++) {
      fcs[i].fx*=imass[i];
      fcs[i].fy*=imass[i];
      fcs[i].fz*=imass[i];
    }
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
  case 2:
    fcr = chip->fcr;
    stepr = chip->stepr;
    for(i=0;i<n;i++) {
      fcr[i].fx*=imass[i];
      fcr[i].fy*=imass[i];
      fcr[i].fz*=imass[i];
    }
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
  case 3:
    fci = chip->Forces->intrF;
    stepi = chip->stepi;
    for(i=0;i<n;i++) {
      fci[i].fx*=imass[i];
      fci[i].fy*=imass[i];
      fci[i].fz*=imass[i];
    }
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
  }
null
null
null
null
null
null
null
  for(i=0;i<chip->tr_count;i++) {
null
null
null
null
null
null
null
null
    switch(type) {
    case 0:
      vel[i].px += fcl[i].fx*stepl;
      vel[i].py += fcl[i].fy*stepl;
      vel[i].pz += fcl[i].fz*stepl;
null
null
null
null
null
null
null
null
    case 1:
      vel[i].px += fcs[i].fx*steps;
      vel[i].py += fcs[i].fy*steps;
      vel[i].pz += fcs[i].fz*steps;
null
null
null
null
null
null
null
null
    case 2:
      vel[i].px += fcr[i].fx*stepr;
      vel[i].py += fcr[i].fy*stepr;
      vel[i].pz += fcr[i].fz*stepr;
null
null
null
null
null
null
null
null
    case 3:
      vel[i].px += (mm=stepi)*fci[i].fx;
      vel[i].py += mm*fci[i].fy;
      vel[i].pz += mm*fci[i].fz;
null
null
null
null
null
null
null
null
    }
    tr[i].px += stepi*vel[i].px;
    tr[i].py += stepi*vel[i].py;
    tr[i].pz += stepi*vel[i].pz;
null
null
null
null
null
null
null
null
  }
null

null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null
null

null
null
null
} /* AdvanceAtoms */

 void freeze_atom_BG(chip_type * chip) {
   int i,j;
   force3 * fca=chip->Forces->intrF;
   char * idx="[freeze_atom]:";
   char id[256];
null
null
null
null
null
   for(i=0;i<chip->nfreeze;i++) {
     j = chip->ifreeze[i];
     chip->tr_vel[j].px = chip->tr_vel[j].py =chip->tr_vel[j].pz = 0;
     chip->fcl[j].fx = chip->fcl[j].fy = chip->fcl[j].fz = 0;
     chip->fcs[j].fx = chip->fcs[j].fy = chip->fcs[j].fz = 0;
     chip->fcr[j].fx = chip->fcr[j].fy = chip->fcr[j].fz = 0;
     fca[j].fx = fca[j].fy = fca[j].fz = 0;
   }
 } /* freeze_atom_BG */

null
